#include <iostream>
#include <fstream>
#include <stdlib.h>

#include <meep.hpp>

using namespace meep;

#include "mmeep_wrapper.h"


////////////////////////////////////////////////////////////////////////////////
//
// MMEEP_WRAPPER
//
////////////////////////////////////////////////////////////////////////////////


void MMEEP_WRAPPER::findSpar(void)
{
    int i = 0;
    //double frequency[nfreq]; // cris: made this member of MMEEP_WRAPPER class;
    double dFreq,freqMax,freqMin;
    std::complex<double> Vt1,It1,Vr1,Ir1;
    std::complex<double> Vt2,It2,Vr2,Ir2;
  

    freqMin=freqBlk-dfBlk/2.;
    freqMax=freqBlk+dfBlk/2.; 

    // \cmt{now, print the Sparameters}
    //double S11[nfreq]; // cris: made this member of MMEEP_WRAPPER class;
    double S11min; 
    //double BW; // cris: made this member of MMEEP_WRAPPER class;
    //int iFreqMin; // cris: made this member of MMEEP_WRAPPER class;
    int iFreqP,iFreqM;
    dFreq=(freqMax-freqMin) / (nfreq-1.);

    //printf("\n\nSpar:#  freq\t_S11\n"); // cris commented out this;

    S11min=999.;
    
    // to print reference data (comment out to run patch antenna)
    //for (i=0; i<nfreq; i++) {
    //   printf("%d\t%lg\n",i,flux1r[i]);
    //} return; 
    // end of "print reference data"


    // cris: moved reading refData.dat inside function read_user_refData();
    // first, read in the flux1r[i] data
    //std::ifstream fin;
    //int j;
    //fin.open("refData.dat");
    //if (!fin) {
    //    std::cout<<"ERROR: input refData.dat file not found!";
    //    exit(1);
    //}
    //std::cout<<"here is the data read in from the file\n";
    //for (i=0; i<nfreq; i++) {
    //    fin>>j>>flux1r[i];
        // std::cout<<j<<"  "<<flux1r[i]<<"\n";
    //}
    //fin.close();
    // std::cout<<"End of data\n";

 
    for (i=0; i<nfreq; i++) {
        _frequency[i]=(freqMin+i*dFreq)*30000/blockCm;
      
        _S11[i] = (flux1r[i]-flux1t[i]) / flux1r[i] ;
        _S11[i] = 10.*log10(_S11[i]);
        //printf("%d\t%f\t%f\n",i,_frequency[i],_S11[i]); // cris commented out this;
        if (_S11[i]<S11min) {
            S11min=_S11[i];
            _iFreqMin=i;
        }
    }
  
    _BW=999.;
  
    if (S11min>=-6) {
        _BW=0.;
        _center_freq = _frequency[_iFreqMin];
        printf("\n Center Frequency = %f ; Bandwidth = %f", _frequency[_iFreqMin], _BW);
        return; 
    }


    // \cmt{find the first frequencies where S11 > -6}
    iFreqP=nfreq-1;
    if (S11min<-6) {
        for(i=_iFreqMin;i<nfreq;i++) {
            if( (_S11[i]>-6) && (iFreqP==nfreq-1) )
                iFreqP=i;
        }
      
        iFreqM=0;
      
        for(i=_iFreqMin;i>=0;i--) {
            if( (_S11[i]>-6) && (iFreqM==0) )
                iFreqM=i;
        }
    }
    //printf("integer frequencies %d  %d  %d\n",iFreqP,_iFreqMin,iFreqM); // cris commented out this;
    

    // \cmt{here, compute the bandwidth using linear interpolation}
    if (_BW!=0) {
        double alpha,freqUpper,freqLower;
      
        alpha=( ( -6 - _S11[iFreqP-1] ) / ( _S11[iFreqP] - _S11[iFreqP-1] ) );
        freqUpper = (1.-alpha)*_frequency[iFreqP-1]
            + alpha * _frequency[iFreqP];

        //printf("alpha for upper _frequency is %f\n",alpha); // cris commented out this;
      
        alpha = ( ( -6 - _S11[iFreqM] ) / ( _S11[iFreqM+1] - _S11[iFreqM] ) );
        freqLower = (1.-alpha)*_frequency[iFreqM] 
            + alpha * _frequency[iFreqM+1];

        // printf("alpha for lower _frequency is %f\n",alpha); // cris commented out this;

        _BW = freqUpper - freqLower;

        // cris commented out this;
        // printf("upper _frequency is %f ; lower _frequency is %f\n\n", freqUpper, freqLower);

        _center_freq = _frequency[_iFreqMin];
        printf("\nCenter Frequency = %f ; Bandwidth = %f", _frequency[_iFreqMin], _BW);
    }
 

    return;
}
